#!/usr/bin/perl -w

require "netsaint-lib.pl";

use vars qw(%required @FIELDS);

%required = (
"command_name","Command Name",
"command_line","Command Line",
);

@FIELDS = ("command_name","command_line");

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_command;
	&list_commands;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_command;
		print <<EOF;
<p>Command $in{'group_name'} saved!<p>
EOF
		&list_commands;
	}
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_command
{
	$in{command_name} =~ tr/ /_/;
	$in{command_name} =~ tr/[a-zA-Z0-9_]//dc;

	$in{'command_line'} =~ s/\\/\\\\/g;
	$in{'command_line'} =~ s/'/\\'/g;
	$in{'command_line'} =~ s/"/\\"/g;
	if ((length($in{'old_command_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_command;
	}
	else
	{
		&update_command;
	}
}

sub delete_command
{
	local($csr);
	local($sql);
	
	$sql = "delete from contact_service_notify where service_notify_command = '$in{'command_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from contact_host_notify where host_notify_command = '$in{'command_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update host set host_check_command = '' where host_check_command = '$in{'command_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from command where command_name = '$in{'command_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_command
{
	local($csr);
	local($sql);
	
	$sql = "insert into command
		(command_name,
		command_line
		)
	values (
		'$in{'command_name'}',
		'$in{'command_line'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_command
{
	local($csr);
	local($sql);

	$sql = "
		update command set
		command_name   = '$in{'command_name'}',
		command_line   = '$in{'command_line'}'
		where
			command_name = '$in{'old_command_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_command
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from command
		where command_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}

sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_command_name'}) > 0)
	{
		$old = "<input type=hidden name=old_command_name value=\"$in{'old_command_name'}\">";
		if (length($in{'command_name'}) <= 0)
		{
			&load_command($in{'old_command_name'});
		}
	}
	$in{'command_line'} =~ s/"/&#147;/g;

#	for ($i = 0; $i < 200; $i++)
#	{
#		print "$i = &#" . $i . ";<br>";
#	}
	
	print <<EOF;
<form action="edit_command.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Command Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=command_name value="$in{'command_name'}" size=30 maxlength=30></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Command Line:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=command_line value="$in{'command_line'}" size=30 maxlength=255></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}


