#!/usr/bin/perl

#use CGI;
#CGI::ReadParse(*in);

require "netsaint-lib.pl";


%required = (
"contact_name","Contact Name",
"email_address","Email Address",
);

@FIELDS = ("contact_name","contact_alias","svc_notification_period","host_notification_period","notify_service_recovery", "notify_service_critical","notify_service_warning","notify_host_recovery","notify_host_down","notify_host_unreachable","email_address","pager");

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_contact;
	&list_contacts;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_contact;
		print <<EOF;
<p>Contact $in{'contact_name'} saved!<p>
EOF
		&list_contacts;
	}
}
elsif ($in{'MODE'} eq "EDIT_NOTIFY")
{
	&edit_notify_commands;
}
elsif ($in{'MODE'} eq "SAVE_NOTIFY_COMMAND")
{
	&save_notify_commands;
	&list_contacts;
}
elsif ($in{'MODE'} eq "EDIT_HOST_NOTIFY")
{
	&edit_host_notify_commands;
}
elsif ($in{'MODE'} eq "SAVE_HOST_NOTIFY_COMMAND")
{
	&save_host_notify_commands;
	&list_contacts;
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_contact
{
        $in{contact_name} =~ tr/ /_/;
        $in{contact_name} =~ tr/[a-zA-Z0-9_]//dc;

	if ((length($in{'old_contact_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_contact;
	}
	else
	{
		&update_contact;
	}
}

sub delete_contact
{
	local($csr);
	local($sql);
	
	$sql = "delete from contact_service_notify where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from contact_host_notify where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from contactgroup_entry where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from contact where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_contact
{
	local($csr);
	local($sql);
	
	$sql = "insert into contact
		(contact_name,
		contact_alias,
		svc_notification_period,
		host_notification_period,
		notify_service_recovery,
		notify_service_critical,
		notify_service_warning,
		notify_host_recovery,
		notify_host_down,
		notify_host_unreachable,
		email_address,
		pager
		)
	values (
		'$in{'contact_name'}',
		'$in{'contact_alias'}',
		'$in{'svc_notification_period'}',
		'$in{'host_notification_period'}',
		 $in{'notify_service_recovery'},
		 $in{'notify_service_critical'},
		 $in{'notify_service_warning'},
		 $in{'notify_host_recovery'},
		 $in{'notify_host_down'},
		 $in{'notify_host_unreachable'},
		'$in{'email_address'}',
		'$in{'pager'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_contact
{
	local($csr);
	local($sql);

	$sql = "
		update contact set
		contact_name             = '$in{'contact_name'}',
		contact_alias            = '$in{'contact_alias'}',
		svc_notification_period  = '$in{'svc_notification_period'}',
		host_notification_period = '$in{'host_notification_period'}',
		notify_service_recovery  =  $in{'notify_service_recovery'},
		notify_service_critical  =  $in{'notify_service_critical'},
		notify_service_warning   =  $in{'notify_service_warning'},
		notify_host_recovery     =  $in{'notify_host_recovery'},
		notify_host_down         =  $in{'notify_host_down'},
		notify_host_unreachable  =  $in{'notify_host_unreachable'},
		email_address            = '$in{'email_address'}',
		pager                    = '$in{'pager'}'

		where
			contact_name = '$in{'old_contact_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_contact
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from contact
		where contact_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}


sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_contact_name'}) > 0)
	{
		$old = "<input type=hidden name=old_contact_name value=\"$in{'old_contact_name'}\">";
		if (length($in{'contact_name'}) <= 0)
		{
			&load_contact($in{'old_contact_name'});
		}
	}
	
	$in{'notify_service_recovery'} = 1 if length($in{'notify_service_recovery'}) <= 0;
	$in{'notify_service_critical'} = 1 if length($in{'notify_service_critical'}) <= 0;
	$in{'notify_service_warning'} = 1 if length($in{'notify_service_warning'}) <= 0;
	$in{'notify_host_recovery'} = 1 if length($in{'notify_host_recovery'}) <= 0;
	$in{'notify_host_down'} = 1 if length($in{'notify_host_down'}) <= 0;
	$in{'notify_host_unreachable'} = 1 if length($in{'notify_host_unreachable'}) <= 0;

	my $nsr = &Zero_One("notify_service_recovery", $in{'notify_service_recovery'});
	my $nsc = &Zero_One("notify_service_critical", $in{'notify_service_critical'});
	my $nsw = &Zero_One("notify_service_warning", $in{'notify_service_warning'});
	my $nhr = &Zero_One("notify_host_recovery", $in{'notify_host_recovery'});
	my $nhd = &Zero_One("notify_host_down", $in{'notify_host_down'});
	my $nhu = &Zero_One("notify_host_unreachable", $in{'notify_host_unreachable'});
	local($svc_notification_period) = &Build_Timeperiod_Select('svc_notification_period', $in{'svc_notification_period'}); 
	local($host_notification_period) = &Build_Timeperiod_Select('host_notification_period', $in{'host_notification_period'}); 
	print <<EOF;
<form action="edit_contact.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Contact Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=contact_name value="$in{'contact_name'}" size=20 maxlength=20></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Contact Alias:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=contact_alias value="$in{'contact_alias'}" size=30 maxlength=30></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Service Notification Period:</b></font></td>
    <td bgcolor="#E1E2ED">$svc_notification_period<td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Service Recovery:</b></font></td>
    <td bgcolor="#E1E2ED">$nsr<td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Service Critical:</b></font></td>
    <td bgcolor="#E1E2ED">$nsc</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Service Warning:</b></font></td>
    <td bgcolor="#E1E2ED">$nsw</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host Notification Period:</b></font></td>
    <td bgcolor="#E1E2ED">$host_notification_period<td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Host Recovery:</b></font></td>
    <td bgcolor="#E1E2ED">$nhr<td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Host Down:</b></font></td>
    <td bgcolor="#E1E2ED">$nhd</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Host Unreachable:</b></font></td>
    <td bgcolor="#E1E2ED">$nhu</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Email Address:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=email_address value="$in{'email_address'}" size=30 maxlength=50></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>E-Pager:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=pager value="$in{'pager'}" size=30 maxlength=80></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}



sub save_notify_commands
{
	local($csr);
	local($csrs);
	local($sql);
	local(@ret);

	$sql = "delete from contact_service_notify where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	
	$sql = "select
			command_name
		from
			command
		order by command_name
	";
	
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($in{$ret[0]} eq "on")
		{
			$sql = "insert into contact_service_notify 
				values (
				'$in{'contact_name'}',
				'$ret[0]'
				)
			";
			$csrs = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
		}
	}

}

sub Has_NotifyCommand
{
	local($contact_name) = shift(@_);
	local($command) = shift(@_);
	local($csr);
	local($sql);
	local(@ret);

	$sql = "select
			count(*)
		from
			contact_service_notify
		where
			contact_name = '$contact_name'
		and 	service_notify_command = '$command'
	";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if (@ret = &my_fetch($csr))
	{
		if ($ret[0] > 0)
		{
			return "checked";
		}

	}
	
	return "";
}

sub edit_notify_commands
{
	local($csr);
	local($sql);
	local(@ret);
	local($odd) = 1;
	local($totcols) = 2;
	local($cols) = $totcols;

	$sql = "select
			command_name
		from
			command
		order by command_name
	";

	print <<EOF;
<center>Edit Notify Commands for contact $in{'contact_name'}</center>
<p>

<form method=post action="edit_contact.cgi">
<input type=submit name=Save value=Save>
<table align=center cellpadding=0 cellspacing=0>
  <tr bgcolor=7172a2>
EOF
	for ($csr = 0; $csr < $totcols; $csr++)
	{
		print <<EOF;
    <td>&#160;</td>
    <td><font color="#DCE5C1"><b>Command Name</b></font></td>
EOF
	}
	print <<EOF;
  </tr>
EOF

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		$checked = &Has_NotifyCommand($in{'contact_name'}, $ret[0]);

		if ($cols == $totcols)
		{
			if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
			print "<tr bgcolor=$color>\n";
		}
		print <<EOF;
    <td><font size=$VAR{'fsize'}><input type=checkbox name=$ret[0] $checked></font></td>
    <td><font size=$VAR{'fsize'}>$ret[0]</font></td>
EOF
		if ($cols == 1)
		{
			print "</tr>\n";
			$cols = $totcols;
		}
		else
		{
			$cols--;
		}
	}
	if ($cols != $totcols)
	{
		while ($cols)
		{
			print "<td bgcolor=$color>&#160;</td>";
			print "<td bgcolor=$color>&#160;</td>";
			$cols--;
		}
		print "</tr>\n";
	}
	print <<EOF;
</table>
<input type=hidden name=contact_name value=$in{'contact_name'}>
<input type=submit name=Save value=Save>
<input type=hidden name=MODE value=SAVE_NOTIFY_COMMAND>
</form>
EOF

}


sub save_host_notify_commands
{
	local($csr);
	local($csrs);
	local($sql);
	local(@ret);

	$sql = "delete from contact_host_notify where contact_name = '$in{'contact_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	
	$sql = "select
			command_name
		from
			command
		order by command_name
	";
	
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($in{$ret[0]} eq "on")
		{
			$sql = "insert into contact_host_notify 
				values (
				'$in{'contact_name'}',
				'$ret[0]'
				)
			";
			$csrs = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
		}
	}

}

sub Has_host_NotifyCommand
{
	local($contact_name) = shift(@_);
	local($command) = shift(@_);
	local($csr);
	local($sql);
	local(@ret);

	$sql = "select
			count(*)
		from
			contact_host_notify
		where
			contact_name = '$contact_name'
		and 	host_notify_command = '$command'
	";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if (@ret = &my_fetch($csr))
	{
		if ($ret[0] > 0)
		{
			return "checked";
		}

	}
	
	return "";
}

sub edit_host_notify_commands
{
	local($csr);
	local($sql);
	local(@ret);
	local($odd) = 1;
	local($totcols) = 2;
	local($cols) = $totcols;

	$sql = "select
			command_name
		from
			command
		order by command_name
	";

	print <<EOF;
<center>Edit Host Notify Commands for contact $in{'contact_name'}</center>
<p>

<form method=post action="edit_contact.cgi">
<input type=submit name=Save value=Save>
<table align=center cellpadding=0 cellspacing=0>
  <tr bgcolor=7172a2>
EOF

	for ($csr = 0; $csr < $totcols; $csr++)
	{
		print <<EOF;
    <td>&#160;</td>
    <td><font color="#DCE5C1"><b>Command Name</b></font></td>
EOF
	}
	print <<EOF;
  </tr>
EOF

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($cols == $totcols)
		{
			if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
			print "<tr bgcolor=$color>\n";
		}
		$checked = &Has_host_NotifyCommand($in{'contact_name'}, $ret[0]);
		print <<EOF;
    <td><font size=$VAR{'fsize'}><input type=checkbox name=$ret[0] $checked></font></td>
    <td><font size=$VAR{'fsize'}>$ret[0]</font></td>
EOF
		if ($cols == 1)
		{
			print "</tr>\n";
			$cols = $totcols;
		}
		else
		{
			$cols--;
		}

	}
	if ($cols != $totcols)
	{
		while ($cols)
		{
			print "<td bgcolor=$color>&#160;</td>";
			print "<td bgcolor=$color>&#160;</td>";
			$cols--;
		}
		print "</tr>\n";
	}
	print <<EOF;
</table>
<input type=hidden name=contact_name value=$in{'contact_name'}>
<input type=submit name=Save value=Save>
<input type=hidden name=MODE value=SAVE_HOST_NOTIFY_COMMAND>
</form>
EOF

}



