#!/usr/bin/perl

#use CGI;
#CGI::ReadParse(*in);

require "netsaint-lib.pl";


%required = (
"group_name","Contact Group Name",
"group_alias","Group Alias",
);

@FIELDS = ("group_name","group_alias");

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_contactgroup;
	&list_contactgroups;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_contactgroup;
		print <<EOF;
<p>Contactgroup $in{'group_name'} saved!<p>
EOF
		&list_contactgroups;
	}
}
elsif ($in{'MODE'} eq "EDIT_CONTACT")
{
	&edit_contacts_form;
}
elsif ($in{'MODE'} eq "SAVE_CONTACT")
{
	&save_contacts;
	&list_contactgroups;
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_contactgroup
{
	$in{group_name} =~ tr/ /_/;
        $in{group_name} =~ tr/[a-zA-Z0-9_]//dc;

	if ((length($in{'old_group_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_contactgroup;
	}
	else
	{
		&update_contactgroup;
	}
}

sub delete_contactgroup
{
	local($csr);
	local($sql);
	
	$sql = "delete from contactgroup_entry where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from contactgroup where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_contactgroup
{
	local($csr);
	local($sql);
	
	$sql = "insert into contactgroup
		(group_name,
		group_alias
		)
	values (
		'$in{'group_name'}',
		'$in{'group_alias'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_contactgroup
{
	local($csr);
	local($sql);

	$sql = "
		update contactgroup set
		group_name          = '$in{'group_name'}',
		group_alias         = '$in{'group_alias'}'
		where
			group_name = '$in{'old_group_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_contactgroup
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from contactgroup
		where group_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}

sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_group_name'}) > 0)
	{
		$old = "<input type=hidden name=old_group_name value=\"$in{'old_group_name'}\">";
		if (length($in{'contact_name'}) <= 0)
		{
			&load_contactgroup($in{'old_group_name'});
		}
	}

	print <<EOF;
<form action="edit_contactgroup.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Group Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=group_name value="$in{'group_name'}" size=20 maxlength=20></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Group Alias:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=group_alias value="$in{'group_alias'}" size=30 maxlength=30></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}





sub Has_Contact
{
	local($group) = shift(@_);
	local($contact) = shift(@_);
	local($csr);
	local($sql);
	local(@ret);

	$sql = "select
			count(*)
		from
			contactgroup_entry
		where
			group_name = '$group'
		and 	contact_name = '$contact'
	";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if (@ret = &my_fetch($csr))
	{
		if ($ret[0] > 0)
		{
			return "checked";
		}

	}
	
	return "";
}

sub edit_contacts_form
{
	local($csr);
	local($sql);
	local(@ret);
	local($odd) = 1;
	local($totcols) = 2;
	local($cols) = $totcols;

	$sql = "select
			contact_name
		from
			contact
		order by contact_name 
	";

	print <<EOF;
<center>Edit Contacts in hostgroup $in{'group_name'}</center>
<p>

<form method=post action="edit_contactgroup.cgi">
<table align=center cellpadding=0 cellspacing=0>
  <tr bgcolor=7172a2>
EOF

	for ($csr = 0; $csr < $totcols; $csr++)
	{
		print <<EOF;
    <td>&#160;</td>
    <td><font color="#DCE5C1"><b>Contact Name</b></font></td>
EOF
	}
	print <<EOF;
  </tr>
EOF

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		$checked = &Has_Contact($in{'group_name'}, $ret[0]);
	
		if ($cols == $totcols)
		{
			if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
			print "<tr bgcolor=$color>\n";
		}
		print <<EOF;
    <td><input type=checkbox name=$ret[0] $checked></td>
    <td>$ret[0]</td>
EOF
		if ($cols == 1)
		{
			print "</tr>\n";
			$cols = $totcols;
		}
		else
		{
			$cols--;
		}

	}
	if ($cols != $totcols)
	{
		while ($cols)
		{
			print "<td bgcolor=$color>&#160;</td>\n";
			print "<td bgcolor=$color>&#160;</td>\n";
			$cols--;
		}
		print "</tr>";
	}
	
	print <<EOF;
</table>
<input type=hidden name=group_name value=$in{'group_name'}>
<input type=submit name=Save value=Save>
<input type=hidden name=MODE value=SAVE_CONTACT>
</form>
EOF
}

sub save_contacts
{
	local($csr);
	local($csrs);
	local($sql);
	local(@ret);

	$sql = "delete from contactgroup_entry where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	
	$sql = "select
			contact_name
		from
			contact
		order by contact_name
	";
	
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($in{$ret[0]} eq "on")
		{
			$sql = "insert into contactgroup_entry 
				(group_name,
				contact_name) 
				values (
				'$in{'group_name'}',
				'$ret[0]'
				)
			";
			$csrs = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
		}
	}

}




