#!/usr/bin/perl

#use CGI;
#CGI::ReadParse(*in);

require "netsaint-lib.pl";


%required = (
"host_name","Host Name",
"address","IP Address",
"host_check_command","Host-check Command",
"max_attempts","Max Attempts",
"notification_interval","Notification Interval",
);

@FIELDS = ('host_name','host_alias','address','parent_host','host_check_command','max_attempts','notification_interval','event_handler', 'notification_period','notify_recovery','notify_down','notify_unreachable');

@NUMERIC = ('max_attempts','notification_interval');

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_host;
	&list_hosts;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form || &host_specific_verify)
	{
		&add_edit_form;
	}
	else
	{
		&save_host;
		print <<EOF;
<p>Host $in{'host_name'} saved!<p>
EOF
		&list_hosts;
	}
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub host_specific_verify
{
	local($retval) = 0;
	
	if ($in{'host_name'} eq $in{'parent_host'})
	{
		print "<font color=red>Parent Host cannot be the same as Host Name.</font><br>\n";
		$retval = 1;
	}
	return $retval;
}


sub save_host
{
	$in{host_name} =~ tr/ /_/;
        $in{host_name} =~ tr/[a-zA-Z0-9_]//dc;

	if ((length($in{'old_host_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_host;
	}
	else
	{
		&update_host;
	}
}

sub delete_host
{
	local($csr);
	local($sql);
	
	$sql = "delete from host where host_name = '$in{'host_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from hostgroup_entry where host_name = '$in{'host_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from service where host = '$in{'host_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_host
{
	local($csr);
	local($sql);
	
	$sql = "insert into host
		(host_name,
		host_alias,
		address,
		parent_host,
		host_check_command,
		max_attempts,
		notification_interval,
		notification_period,
		notify_recovery,
		notify_down,
		notify_unreachable,
		event_handler
		)
	values (
		'$in{'host_name'}',
		'$in{'host_alias'}',
		'$in{'address'}',
		'$in{'parent_host'}',
		'$in{'host_check_command'}',
		$in{'max_attempts'},
		$in{'notification_interval'},
		'$in{'notification_period'}',
		$in{'notify_recovery'},
		$in{'notify_down'},
		$in{'notify_unreachable'},
		'$in{'event_handler'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_host
{
	local($csr);
	local($sql);

	$sql = "
		update host set
		host_name             = '$in{'host_name'}',
		host_alias            = '$in{'host_alias'}',
		address               = '$in{'address'}',
		parent_host           = '$in{'parent_host'}',
		host_check_command    = '$in{'host_check_command'}',
		max_attempts          =  $in{'max_attempts'},
		notification_interval =  $in{'notification_interval'},
		notification_period   =  '$in{'notification_period'}',
		notify_recovery       =  $in{'notify_recovery'},
		notify_down           =  $in{'notify_down'},
		notify_unreachable    =  $in{'notify_unreachable'},
		event_handler         = '$in{'event_handler'}'

		where
			host_name = '$in{'old_host_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_host
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from host
		where host_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}


sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_host_name'}) > 0)
	{
		$old = "<input type=hidden name=old_host_name value=\"$in{'old_host_name'}\">";
		if (length($in{'host_name'}) <= 0)
		{
			&load_host($in{'old_host_name'});
		}
		else
		{
			$in{'host_check_command'} = 'check-host-alive' if (length($in{'host_check_command'}) <= 0);
			$in{'max_attempts'} = 3 if (length($in{'max_attempts'}) <= 0);
			$in{'notification_interval'} = 120 if (length($in{'notification_interval'}) <= 0);
		}
	}
	else
	{
		$in{'host_check_command'} = 'check-host-alive' if (length($in{'host_check_command'}) <= 0);
		$in{'max_attempts'} = 3 if (length($in{'max_attempts'}) <= 0);
		$in{'notification_interval'} = 120 if (length($in{'notification_interval'}) <= 0);
	}

	$in{'notify_recovery'} = 1 if (length($in{'notify_recovery'}) <= 0);
	$in{'notify_down'} = 1 if (length($in{'notify_down'}) <= 0);
	$in{'notify_unreachable'} = 1 if (length($in{'notify_unreachable'}) <= 0);
	my $notify_recovery = &Zero_One('notify_recovery',$in{'notify_recovery'});
	my $notify_down = &Zero_One('notify_down',$in{'notify_down'});
	my $notify_unreachable = &Zero_One('notify_unreachable',$in{'notify_unreachable'});


	local($host) = &build_host_select('parent_host',$in{'parent_host'});
	local($check_command) = &build_command_select('host_check_command',$in{'host_check_command'});
	local($notification_period) = &Build_Timeperiod_Select('notification_period', $in{'notification_period'});
	local($event_handler) = &build_command_select('event_handler',$in{'event_handler'});

	print <<EOF;
<form action="edit_host.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=host_name value="$in{'host_name'}" size=20 maxlength=20></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host Alias:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=host_alias value="$in{'host_alias'}" size=30 maxlength=30></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Address:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=address value="$in{'address'}" size=20 maxlength=20></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Parent Host:</b></font></td>
    <td bgcolor="#E1E2ED">$host</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host-check Command:</b></font></td>
    <td bgcolor="#E1E2ED">$check_command</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Max Attempts:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=max_attempts value="$in{'max_attempts'}" size=4 maxlength=4> <font color=red>(numeric only)</font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notification Interval:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=notification_interval value="$in{'notification_interval'}" size=4 maxlength=4> Minutes <font color=red>(numeric only)</font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notification Period:</b></font></td>
    <td bgcolor="#E1E2ED">$notification_period</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Recovery:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_recovery</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Down:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_down</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Unreachable:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_unreachable</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Event Handler:</b></font></td>
    <td bgcolor="#E1E2ED">$event_handler</td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}


