#!/usr/bin/perl

require "netsaint-lib.pl";

%required = (
"group_name","Group Name"
);

@FIELDS = ('group_name','group_alias');

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_hostgroup;
	&list_hostgroups;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_hostgroup;
		print <<EOF;
<p>Host $in{'host_name'} saved!<p>
EOF
		&list_hostgroups;
	}
}
elsif ($in{'MODE'} eq "EDIT_HOST")
{
	&edit_hosts_form;
}
elsif ($in{'MODE'} eq "SAVE_HOST")
{
	&save_hosts;
	&list_hostgroups;
}
elsif ($in{'MODE'} eq "EDIT_CONTACT")
{
	&edit_contacts_form;
}
elsif ($in{'MODE'} eq "SAVE_CONTACT")
{
	&save_contactgroups;
	&list_hostgroups;
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub Has_ContactGroup
{
	local($group) = shift(@_);
	local($contact) = shift(@_);
	local($csr);
	local($sql);
	local(@ret);

	$sql = "select
			count(*)
		from
			hostgroup_contact
		where
			group_name = '$group'
		and 	contact_group = '$contact'
	";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if (@ret = &my_fetch($csr))
	{
		if ($ret[0] > 0)
		{
			return "checked";
		}

	}
	
	return "";
}

sub edit_contacts_form
{
	local($csr);
	local($sql);
	local(@ret);
	local($odd) = 1;

	$sql = "select
			group_name
		from
			contactgroup
		order by group_name 
	";

	print <<EOF;
<center>Edit Contacts in hostgroup $in{'group_name'}</center>
<p>

<form method=post action="edit_hostgroup.cgi">
<table align=center cellpadding=0 cellspacing=0>
  <tr bgcolor=7172a2>
    <td>&#160;</td>
    <td><font color="#DCE5C1"><b>Contact Groups</b></font></td>
  </tr>
EOF

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		$checked = &Has_ContactGroup($in{'group_name'}, $ret[0]);
		print <<EOF;
  <tr bgcolor=$color>
    <td><input type=checkbox name=$ret[0] $checked></td>
    <td><font size=-1>$ret[0]</font></td>
  </tr>
EOF

	}
	print <<EOF;
</table>
<input type=hidden name=group_name value=$in{'group_name'}>
<input type=submit name=Save value=Save>
<input type=hidden name=MODE value=SAVE_CONTACT>
</form>
EOF
}

sub save_contactgroups
{
	local($csr);
	local($csrs);
	local($sql);
	local(@ret);

	$sql = "delete from hostgroup_contact where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	
	$sql = "select
			group_name
		from
			contactgroup
		order by group_name
	";
	
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($in{$ret[0]} eq "on")
		{
			$sql = "insert into hostgroup_contact 
				values (
				'$in{'group_name'}',
				'$ret[0]'
				)
			";
			$csrs = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
		}
	}

}

sub save_hosts
{
	local($csr);
	local($csrs);
	local($sql);
	local(@ret);

	$sql = "delete from hostgroup_entry where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	
	$sql = "select
			host_name
		from
			host
		order by host_name
	";
	
	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		if ($in{$ret[0]} eq "on")
		{
			$sql = "insert into hostgroup_entry 
				values (
				'$in{'group_name'}',
				'$ret[0]'
				)
			";
			$csrs = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
		}
	}

}

sub Has_Host
{
	local($group) = shift(@_);
	local($host) = shift(@_);
	local($csr);
	local($sql);
	local(@ret);

	$sql = "select
			count(*)
		from
			hostgroup_entry
		where
			group_name = '$group'
		and 	host_name = '$host'
	";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if (@ret = &my_fetch($csr))
	{
		if ($ret[0] > 0)
		{
			return "checked";
		}

	}
	
	return "";
}

sub edit_hosts_form
{
	local($totcols) = 3;
	local($csr);
	local($sql);
	local(@ret);
	local($odd) = 1;
	local($cols) = $totcols;

	$sql = "select
			host_name
		from
			host
		order by host_name 
	";

	print <<EOF;
<center>Edit Hosts in hostgroup $in{'group_name'}</center>
<p>

<form method=post action="edit_hostgroup.cgi">
<table align=center cellpadding=0 cellspacing=0>
  <tr bgcolor=7172a2>
EOF
	for ($csr = 0; $csr < $totcols; $csr++)
	{
		print <<EOF;
    <td>&#160;</td>
    <td><font color="#DCE5C1"><b>Host Name</b></font></td>
EOF
	}
	print "</tr>\n";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	while (@ret = &my_fetch($csr))
	{
		$checked = &Has_Host($in{'group_name'}, $ret[0]);

		if ($cols == $totcols)
		{
			if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
  			print "<tr bgcolor=$color>";
		}
		print <<EOF;
    <td><font size=-1><input type=checkbox name=$ret[0] $checked></font></td>
    <td><font size=-1>$ret[0]</font></td>
EOF
		if ($cols == 1)
		{
			print "</tr>\n";
			$cols = $totcols;
		}
		else
		{
			$cols--;
		}

	}
	if ($cols > 1)
	{
		while ($cols > 1)
		{
			print "<td bgcolor=$color>&#160;</td>";
			print "<td bgcolor=$color>&#160;</td>";
			$cols--;
		}
		print "</tR>";
	}
	print <<EOF;
</table>
<input type=hidden name=group_name value=$in{'group_name'}>
<input type=submit name=Save value=Save>
<input type=hidden name=MODE value=SAVE_HOST>
</form>
EOF

}


sub save_hostgroup
{
	$in{group_name} =~ tr/ /_/;
	$in{group_name} =~ tr/[a-zA-Z0-9_]//dc;

	if ((length($in{'old_group_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_hostgroup;
	}
	else
	{
		&update_hostgroup;
	}
}

sub delete_hostgroup
{
	local($csr);
	local($sql);
	
	$sql = "delete from hostgroup_entry where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from hostgroup_contact where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from hostgroup where group_name = '$in{'group_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_hostgroup
{
	local($csr);
	local($sql);
	
	$sql = "insert into hostgroup
		(
		group_name,
		group_alias)
	values (
		'$in{'group_name'}',
		'$in{'group_alias'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_hostgroup
{
	local($csr);
	local($sql);


	$sql = "
		update hostgroup set
		group_name             = '$in{'group_name'}',
		group_alias            = '$in{'group_alias'}'
		where
			group_name = '$in{'old_group_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}


sub load_hostgroup
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from hostgroup
		where group_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}


sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_group_name'}) > 0)
	{
		$old = "<input type=hidden name=old_group_name value=\"$in{'old_group_name'}\">";
		if (length($in{'group_name'}) <= 0)
		{
			&load_hostgroup($in{'old_group_name'});
		}
	}
	local($host) = &build_host_select('hosts');

	print <<EOF;
<form action="edit_hostgroup.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=group_name value="$in{'group_name'}" size=20 maxlength=20></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host Alias:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=group_alias value="$in{'group_alias'}" size=30 maxlength=30></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}



