#!/usr/bin/perl

#use CGI;
#CGI::ReadParse(*in);

require "netsaint-lib.pl";


%required = (
"host","Host Name",
"description","Description",
"max_attempts","Max Attempts",
"check_interval","Check Interval",
"retry_interval","Retry Interval",
"notification_group","Notification Group",
"notification_interval","Notification Interval",
"notification_period","Notification Period",
"notify_recovery","Notify Recovery",
"notify_critical","Notify Critical",
"notify_warning","Notify Warning",
"check_command","Check Command"
);

@FIELDS = ('service_id', 'host','description','max_attempts','check_interval','retry_interval','notification_interval','notify_recovery','notify_critical', 'notify_warning','event_handler','check_command','check_arg','notification_group','notification_period','check_period');

@NUMERIC = ('max_attempts','notification_interval','check_interval','retry_interval','notify_recovery','notify_critical','notify_warning');

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_service;
	&list_services;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_service;
		print <<EOF;
<p>Service $in{'host'}:$in{'description'} saved!<p>
EOF
		&list_services;
	}
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_service
{
	if ((length($in{'service_id'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_service;
	}
	else
	{
		&update_service;
	}
}

sub delete_service
{
	local($csr);
	local($sql);
	
	$sql = "delete from service where service_id = '$in{'service_id'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_service
{
	local($csr);
	local($sql);
	
	$sql = "insert into service
		(host,
		description,
		check_period,
		max_attempts,
		check_interval,
		retry_interval,
		notification_group,
		notification_interval,
		notification_period,
		notify_recovery,
		notify_critical,
		notify_warning,
		event_handler,
		check_command,
		check_arg)
	values (
		'$in{'host'}',
		'$in{'description'}',
		'$in{'check_period'}',
		$in{'max_attempts'},
		$in{'check_interval'},
		$in{'retry_interval'},
		'$in{'notification_group'}',
		$in{'notification_interval'},
		'$in{'notification_period'}',
		$in{'notify_recovery'},
		$in{'notify_critical'},
		$in{'notify_warning'},
		'$in{'event_handler'}',
		'$in{'check_command'}',
		'$in{'check_arg'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_service
{
	local($csr);
	local($sql);

	$sql = "
		update 
			service 
		set
			host                  = '$in{'host'}',
			description           = '$in{'description'}',
			check_period          = '$in{'check_period'}',
			max_attempts          = $in{'max_attempts'},
			check_interval        = $in{'check_interval'},
			retry_interval        = $in{'retry_interval'},
			notification_group    = '$in{'notification_group'}',
			notification_interval = $in{'notification_interval'},
			notification_period   = '$in{'notification_period'}',
			notify_recovery       = $in{'notify_recovery'},
			notify_critical       = $in{'notify_critical'},
			notify_warning        = $in{'notify_warning'},
			event_handler         = '$in{'event_handler'}',
			check_command         = '$in{'check_command'}',
			check_arg         = '$in{'check_arg'}'
		where
			service_id = '$in{'service_id'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_service
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from service
		where service_id = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}


sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'service_id'}) > 0)
	{
		$old = "<input type=hidden name=service_id value=\"$in{'service_id'}\">";
		if (length($in{'host'}) <= 0)
		{
			&load_service($in{'service_id'});
		}
	}

	$in{'max_attempts'} = 3 if (length($in{'max_attempts'}) <= 0);
	$in{'check_interval'} = 5 if (length($in{'check_interval'}) <= 0);
	$in{'retry_interval'} = 1 if (length($in{'retry_interval'}) <= 0);
	$in{'notification_interval'} = 120 if (length($in{'notification_interval'}) <= 0);
	
	$in{'notify_recovery'} = 1 if (length($in{'notify_recovery'}) <= 0);
	$in{'notify_warning'} = 1 if (length($in{'notify_warning'}) <= 0);
	$in{'notify_critical'} = 1 if (length($in{'notify_critical'}) <= 0);

	local($check_period) = &Build_Timeperiod_Select('check_period', $in{'check_period'});
	local($notification_period) = &Build_Timeperiod_Select('notification_period', $in{'notification_period'});
	local($notification_group) = &Build_Contactgroup_Select('notification_group', $in{'notification_group'});
	local($host) = &build_host_select('host',$in{'host'});
	local($check_command) = &build_command_select('check_command',$in{'check_command'});
	local($notify_recovery) = &Zero_One('notify_recovery',$in{'notify_recovery'});
	local($notify_critical) = &Zero_One('notify_critical',$in{'notify_critical'});
	local($notify_warning) = &Zero_One('notify_warning',$in{'notify_warning'});
	local($event_handler) = &build_command_select('event_handler',$in{'event_handler'});

	print <<EOF;
<form action="edit_service.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Host:</b></font></td>
    <td bgcolor="#E1E2ED">$host</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Description:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=description value="$in{'description'}" size=30 maxlength=30></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Check Period:</b></font></td>
    <td bgcolor="#E1E2ED">$check_period</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Max Attempts:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=max_attempts value="$in{'max_attempts'}" size=4 maxlength=4> Minutes <font color=red>(numeric only) </font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Check Interval:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=check_interval value="$in{'check_interval'}" size=4 maxlength=4> Minutes <font color=red>(numeric only)</font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Retry Interval:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=retry_interval value="$in{'retry_interval'}" size=4 maxlength=4> Minutes <font color=red>(numeric only)</font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notification Group:</b></font></td>
    <td bgcolor="#E1E2ED">$notification_group</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notification Interval:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=notification_interval value="$in{'notification_interval'}" size=4 maxlength=4> Minutes <font color=red>(numeric only)</font></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notification Period:</b></font></td>
    <td bgcolor="#E1E2ED">$notification_period</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Recovery:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_recovery</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Critical:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_critical</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Notify Warning:</b></font></td>
    <td bgcolor="#E1E2ED">$notify_warning</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Event Handler:</b></font></td>
    <td bgcolor="#E1E2ED">$event_handler</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Check Command:</b></font></td>
    <td bgcolor="#E1E2ED">$check_command</td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Check Command Arguments:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=check_arg value="$in{'check_arg'}" size=30 maxlength=255></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}



