#!/usr/bin/perl

require "netsaint-lib.pl";

#&check_cookie;


%required = (
"timeperiod_name","Timeperiod Name",
"timeperiod_alias","Timeperiod Alias",
);

@FIELDS = ("timeperiod_alias","timeperiod_name");

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

if ($in{'MODE'} eq "EDIT")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "DELETE")
{
	&delete_timeperiod;
	&list_timeperiods;
}
elsif ($in{'MODE'} eq "ADD")
{
	&add_edit_form;
}
elsif ($in{'MODE'} eq "SAVE")
{
	if (&verify_form)
	{
		&add_edit_form;
	}
	else
	{
		&save_timeperiod;
		print <<EOF;
<p>Timeperiod $in{'timeperiod_name'} saved!<p>
EOF
		&list_timeperiods;
	}
}
elsif ($in{'MODE'} eq "EDIT_DAY")
{
	&list_a_day;
}
elsif ($in{'MODE'} eq "ADD_TIME")
{
	&add_edit_time;
}
elsif ($in{'MODE'} eq "SAVE_TIME")
{
	&save_update_time;
	&list_a_day;
}
elsif ($in{'MODE'} eq "DELETE_TIME")
{
	&delete_time_day;
	&list_a_day;
}
else
{
	print <<EOF;
Invalid Mode.
EOF
}

print <<EOF;
</body>
</html>

EOF

exit(1);

sub save_timeperiod
{
        $in{timeperiod_name} =~ tr/ /_/;
        $in{timeperiod_name} =~ tr/[a-zA-Z0-9_]//dc;

	if ((length($in{'old_timeperiod_name'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_timeperiod;
	}
	else
	{
		&update_timeperiod;
	}
}

sub delete_timeperiod
{
	local($csr);
	local($sql);
	
	$sql = "delete from timeperiod where timeperiod_name = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "delete from time_day where timeperiod_name = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update host set notification_period = '' where notification_period = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update service set check_period = '' where check_period = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update service set notification_period = '' where notification_period = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update contact set svc_notification_period = '' where svc_notification_period = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	$sql = "update contact set host_notification_period = '' where host_notification_period = '$in{'timeperiod_name'}'";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub insert_timeperiod
{
	local($csr);
	local($sql);
	
	$sql = "insert into timeperiod
		(timeperiod_name,
		timeperiod_alias
		)
	values (
		'$in{'timeperiod_name'}',
		'$in{'timeperiod_alias'}'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_timeperiod
{
	local($csr);
	local($sql);

	$sql = "
		update timeperiod set
		timeperiod_name   = '$in{'timeperiod_name'}',
		timeperiod_alias  = '$in{'timeperiod_alias'}'
		where
			timeperiod_name = '$in{'old_timeperiod_name'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}



sub load_timeperiod
{
	local($name) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select *
		from timeperiod
		where timeperiod_name = '$name'";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}

sub BuildTimeDropdown
{
	my $name = shift;
	my $value = shift;
	my $increments = shift;
	my $retval = "";
	my $selected = "";

#	print "N:$name, V:$value<br>";

	#$retval = "<select name=$name>\n";

	#for ($i = "00"; $i ne "24"; $i++)
	#{
	#	$selected = ""; $selected = "selected" if ($value eq "$i:00");
	#	$retval .= "<option $selected value=\"$i:00\">$i:00</option>\n";
	#	$selected = ""; $selected = "selected" if ($value eq "$i:15");
	#	$retval .= "<option $selected value=\"$i:15\">$i:15</option>\n";
	#	$selected = ""; $selected = "selected" if ($value eq "$i:30");
	#	$retval .= "<option $selected value=\"$i:30\">$i:30</option>\n";
	#	$selected = ""; $selected = "selected" if ($value eq "$i:45");
	#	$retval .= "<option $selected value=\"$i:45\">$i:45</option>\n";
	#}

	#$selected = ""; $selected = "selected" if ($value eq "24:00");
	#$retval .= "<option $selected value=\"24:00\">24:00</option>\n";

	#$retval .= "</select>\n";

	my $z = 0;
	for ($i = "00"; $i ne "24"; $i++)
	{
		@ARR[$z] = "$i:00"; $z++;
		@ARR[$z] = "$i:15"; $z++;
		@ARR[$z] = "$i:30"; $z++;
		@ARR[$z] = "$i:45"; $z++;
	}
	@ARR[$z] = "24:00";

	$retval = popup_menu(-name=>$name, -values=>\@ARR, -default=>$value);

	return $retval;
}


sub add_edit_form
{
	local($old) = "";
	
	if (length($in{'old_timeperiod_name'}) > 0)
	{
		$old = "<input type=hidden name=old_timeperiod_name value=\"$in{'old_timeperiod_name'}\">";
		if (length($in{'timeperiod_name'}) <= 0)
		{
			&load_timeperiod($in{'old_timeperiod_name'});
		}
	}
	
	print <<EOF;
<form action="edit_timeperiod.cgi" method=post>
$old
<table cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Timeperiod Name (one word):</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=timeperiod_name value="$in{'timeperiod_name'}" size=30 maxlength=30></td>
  </tr>
  <tr>
    <td bgcolor=7172a2 align=right><font color="#DCE5C1"><b>Timeperiod Alias:</b></font></td>
    <td bgcolor="#E1E2ED"><input type=text name=timeperiod_alias value="$in{'timeperiod_alias'}" size=30 maxlength=100></td>
  </tr>
</table>
<input type=hidden name=MODE value=SAVE>
<input type=submit value=Save name=Save>  ... as New <input type=checkbox name=AS_NEW >
</form>

EOF

}


sub list_a_day
{
	my $sql;
	my $csr;
	my @ret;
	my $color = "";
	my $odd = 1;

	$sql = " select
			start,
			stop,
			id
		from
			time_day
		where
			timeperiod_name = '$in{'timeperiod_name'}'
		and 	day = '$in{'day'}'
		order by start,stop
		";

	print <<EOF;
<table align=center cellpading=1 cellspacing=1 border=0>
<tr bgcolor=7172a2 align=center>
  <td colspan=4><font color="#DCE5C1"><b>$in{'timeperiod_name'} / $in{'day'}</b></font></td>
</tr>
<tr bgcolor=7172a2 align=center>
  <td><font size=$VAR{'fsize'}><a href="edit_timeperiod.cgi?MODE=ADD_TIME&day=$in{'day'}&timeperiod_name=$in{'timeperiod_name'}">Add</a></font></td>
  <td><font color="#DCE5C1"><b>Start</b></font></td>
  <td><font color="#DCE5C1"><b>Stop</b></font></td>
  <td>&#160;</td>
</tr>
EOF
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>\n$sql<p>\n";
	while (@ret = &my_fetch($csr))
	{
		if ($odd) { $odd=0; $color="E1E2ED";} else { $odd=1; $color="EEEEF4";}
		print <<EOF;
<tr bgcolor=$color align=center>
  <td><font size=$VAR{'esize'}><a href="edit_timeperiod.cgi?MODE=ADD_TIME&day=$in{'day'}&timeperiod_name=$in{'timeperiod_name'}&id=$ret[2]">Edit</a></font></td>
  <td><font size=$VAR{'fsize'}>$ret[0]</font></td>
  <td><font size=$VAR{'fsize'}>$ret[1]</font></td>
  <td><font size=$VAR{'dsize'}><a href="edit_timeperiod.cgi?MODE=DELETE_TIME&id=$ret[2]&day=$in{'day'}&timeperiod_name=$in{'timeperiod_name'}">Delete</a></font></td>
</tr>
EOF
	}

	print <<EOF;
</table>
EOF

}


sub add_edit_time
{
	if ($in{'id'} > 0)
	{
		&load_day_time($in{'id'});
		my ($one, $two, $three) = split(/:/, $in{start});
		$in{start} = "$one:$two";
		($one, $two, $three) = split(/:/, $in{stop});
		$in{stop} = "$one:$two";
	}

	my $start = &BuildTimeDropdown("start", $in{'start'});
	my $stop = &BuildTimeDropdown("stop", $in{'stop'});

	print <<EOF;
<form action="edit_timeperiod.cgi">
<input type=hidden name=MODE value=SAVE_TIME>
<input type=hidden name=id value=$in{'id'}>
<input type=hidden name=day value=$in{'day'}>
<input type=hidden name=timeperiod_name value=$in{'timeperiod_name'}>
<table align=center cellpading=1 cellspacing=1 border=0>
  <tr bgcolor=7172a2 align=center>
    <td colspan=3><font color="#DCE5C1"><b>$in{'timeperiod_name'} / $in{'day'}</b></font></td>
  </tr>
  <tr bgcolor=7172a2 align=center>
    <td><font color="#DCE5C1"><b>$start</b></font></td>
    <td><font color="#DCE5C1"><b>$stop</b></font></td>
    <td align=center>
      <font color="#DCE5C1"><b><input type=submit name=Save value=Save></b></font>
    </td>
  </tr>
</table>
</form>
EOF

}


sub save_update_time
{
	if ((length($in{'id'}) <= 0) ||
	    ($in{'AS_NEW'} eq "on"))
	{
		&insert_day_time;
	}
	else
	{
		&update_day_time;
	}
}

sub insert_day_time
{
	local($csr);
	local($sql);
	
	$sql = "insert into time_day
		(timeperiod_name,
		day,
		start,
		stop
		)
	values (
		'$in{'timeperiod_name'}',
		'$in{'day'}',
		'$in{'start'}:00',
		'$in{'stop'}:00'
		)
		";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";

}

sub update_day_time
{
	local($csr);
	local($sql);

	$sql = "
		update time_day set
		timeperiod_name = '$in{'timeperiod_name'}',
		day             = '$in{'day'}',
		start           = '$in{'start'}:00',
		stop            = '$in{'stop'}:00'
		where
			id = '$in{'id'}'
		";
	
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}

sub load_day_time
{
	local($id) = shift(@_);
	local($csr);
	local($sql);
	local(%data);
	local($ret);
	
	$sql = "select 
			*
		from 
			time_day
		where 
			id = $id
		";

	$csr = &my_open($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
	if ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		foreach $sql (keys %data)
		{
			$in{$sql} = $data{$sql};
		}
	}

}

sub delete_time_day
{
	local($csr);
	local($sql);
	
	$sql = "delete from time_day where id = $in{'id'}";
	$csr = &my_do($dbh, $sql) || print "<p>$my_errstr<p>$sql<p>";
}
