#!/usr/bin/perl

require "netsaint-lib.pl";

print <<EOF;

<html>

<head>
<title>Netsaint config</title>
</head>

<body>
EOF

&Build_hosts;

print <<EOF;
</body>
</html>

EOF

exit(1);


sub Build_hosts
{
	local($sql);
	local(@ret);
	local(%data);
	local($ret);
	local($csr);
	local($tmp) = "";
	local($endit) = 0;

	if (!(open(FL, ">$hosts_loc/hosts.tmp")))
	{
		$endit = 1;
	}

	if ($endit)
	{
		print "Can't open file for write! ($hosts_loc/hosts.tmp)";
		return;
	}

	print "<b>Writing Timeperiods....</b> ";
	$sql = "select * from timeperiod order by timeperiod_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Hosts\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'timeperiod_name'}, ";
		print FL "timeperiod[$data{'timeperiod_name'}]=$data{'timeperiod_alias'};";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "SUN") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "MON") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "TUE") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "WED") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "THU") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "FRI") . ";";
		print FL &List_Times_Comma($data{'timeperiod_name'}, "SAT") . "\n";
	}
	print "Done!<br>\n";

	print "<b>Writing hosts....</b> ";
	$sql = "select * from host order by host_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Hosts\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'host_name'}, ";
		print FL "host[$data{'host_name'}]=$data{'host_alias'};$data{'address'};$data{'parent_host'};$data{'host_check_command'};$data{'max_attempts'};$data{'notification_interval'};$data{'notification_period'};$data{'notify_recovery'};$data{'notify_down'};$data{'notify_unreachable'};$data{'event_handler'}\n";
	}
	print "Done!<br>\n";

	print "<b>Writing hostgroups.... </b>";
	$sql = "select * from hostgroup order by group_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Hostgroups\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'group_name'}, ";
		print FL "hostgroup[$data{'group_name'}]=$data{'group_alias'};";
	
		local($ret2);
		local(%data2);
		local($csr2);
	
		$sql = "select * from hostgroup_contact where group_name = '$data{'group_name'}'";
		$csr2 = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
		$tmp = "";
		while ($ret2 = $csr2->fetchrow_hashref)
		{
			*data2 = $ret2;
			$tmp .= "$data2{'contact_group'},";
		}
		if (length($tmp) > 0) { chop($tmp); }
		print FL "$tmp;";
		
		$sql = "select * from hostgroup_entry where group_name = '$data{'group_name'}'";
		$csr2 = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
		$tmp = "";
		while ($ret2 = $csr2->fetchrow_hashref)
		{
			*data2 = $ret2;
			$tmp .= "$data2{'host_name'},";
		}
		if (length($tmp) > 0) { chop($tmp); }
		print FL "$tmp\n";

	}
	print "Done!<br>\n";


	print "<b>Writing commands.... </b>";
	$sql = "select * from command order by command_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Commands\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'command_name'}, ";
		$data{'command_line'} =~ s/\n/\\n/g;
		print FL "command[$data{'command_name'}]=$data{'command_line'}\n";
	}
	print "Done!<br>\n";
	
	print "<b>Writing contacts.... </b>";
	$sql = "select * from contact order by contact_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Contacts\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'contact_name'}, ";
		$data{'command_line'} =~ s/\n/\\n/g;
		print FL "contact[$data{'contact_name'}]=$data{'contact_alias'};$data{'svc_notification_period'};$data{'host_notification_period'};$data{'notify_service_recovery'};$data{'notify_service_critical'};$data{'notify_service_warning'};$data{'notify_host_recovery'};$data{'notify_host_down'};$data{'notify_host_unreachable'};";

		local($ret2);
		local(%data2);
		local($csr2);
	
		$sql = "select * from contact_service_notify where contact_name = '$data{'contact_name'}'";
		$csr2 = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
		$tmp = "";
		while ($ret2 = $csr2->fetchrow_hashref)
		{
			*data2 = $ret2;
			$tmp .= "$data2{'service_notify_command'},";
		}
		if (length($tmp) > 0) { chop($tmp); }
		print FL "$tmp;";

		$sql = "select * from contact_host_notify where contact_name = '$data{'contact_name'}'";
		$csr2 = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
		$tmp = "";
		while ($ret2 = $csr2->fetchrow_hashref)
		{
			*data2 = $ret2;
			$tmp .= "$data2{'host_notify_command'},";
		}
		if (length($tmp) > 0) { chop($tmp); }
		print FL "$tmp;";

		print FL "$data{'email_address'};$data{'pager'}\n";


	}
	print "Done!<br>\n";

	print "<b>Writing contactgroups.... </b>";
	$sql = "select * from contactgroup order by group_name ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Contactgroups\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'group_name'}, ";

		print FL "contactgroup[$data{'group_name'}]=$data{'group_alias'};";
		
		$sql = "select * from contactgroup_entry where group_name = '$data{'group_name'}'";
		$csr2 = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
		$tmp = "";
		while ($ret2 = $csr2->fetchrow_hashref)
		{
			*data2 = $ret2;
			$tmp .= "$data2{'contact_name'},";
		}
		if (length($tmp) > 0) { chop($tmp); }
		print FL "$tmp\n";
		
		
	}
	print "Done!<br>\n";
	
	print "<b>Writing services.... </b>";
	$sql = "select * from service order by host,description ";
	$csr = &my_open($dbh, $sql) || print "$my_errstr<p>$sql<p>";
	print FL "\n# Services\n";
	while ($ret = $csr->fetchrow_hashref)
	{
		*data = $ret;
		print "$data{'host'}/$data{'description'}, ";

		print FL "service[$data{'host'}]=$data{'description'};$data{'check_period'};$data{'max_attempts'};$data{'check_interval'};$data{'retry_interval'};$data{'notification_group'};$data{'notification_interval'};$data{'notification_period'};$data{'notify_recovery'};$data{'notify_critical'};$data{'notify_warning'};$data{'event_handler'};$data{'check_command'}";

		if (length($data{'check_arg'}) > 0)
		{
			$data{'check_arg'} =~ s/ /!/g;
			print FL "!$data{'check_arg'}";
		}

		print FL "\n";


	}
	print "Done!<br>\n";
	

	close(FL);
}



